#!/bin/bash
# license: gpl2p 

### BEGIN LICENSE NOTICE
# This file is part of %LONG% (%SHORT%)
# Copyright (C) 2010 - %YEAR%
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST

set -e

if [ -f "${HOME}/.rvm/scripts/rvm" ]; then
  source "${HOME}/.rvm/scripts/rvm"
elif [ -f "/etc/profile.d/rvm.sh" ]; then
  source "/etc/profile.d/rvm.sh"
fi

rvm install --force jruby-1.7.19
rvm jruby-1.7.19
rvm gemset create io
rvm jruby-1.7.19@io

set -x

ruby --1.9 -S gem install --no-user-install --version 4.1.8 activerecord
ruby --1.9 -S gem install --no-user-install --version 4.1.8 activesupport
ruby --1.9 -S gem install --no-user-install --version 4.1.8 activerecord
ruby --1.9 -S gem install --no-user-install --version 1.3.13 activerecord-jdbcmysql-adapter



ruby --1.9 -S gem install --no-user-install --version 0.7.7 jruby-openssl
ruby --1.9 -S gem install --no-user-install --version 2.5.2 net-ssh
ruby --1.9 -S gem install --no-user-install --version 1.0.9 ruby-graphviz
ruby --1.9 -S gem install --no-user-install --version 1.2.0 ruby-graphviz
ruby --1.9 -S gem install --no-user-install --version 0.9.6 os

ruby --1.9 -S gem install --no-user-install --version 1.1.10 log4r

ruby --1.9 -S gem install --no-user-install --version 5.1.28 jdbc-mysql
ruby --1.9 -S gem install --no-user-install --version 0.8.0 ipaddress
ruby --1.9 -S gem install --no-user-install --version 1.1.0 snmp

cd "${GEM_HOME}"

patch -R -p1 -b -s <<EOF
diff -Naur jruby-1.7.5@io/gems/log4r-1.1.10/lib/log4r/outputter/outputterfactory.rb jruby-1.7.19@iofoo/gems/log4r-1.1.10/lib/log4r/outputter/outputterfactory.rb
--- jruby-1.7.5@io/gems/log4r-1.1.10/lib/log4r/outputter/outputterfactory.rb    2015-01-08 13:37:38.268154745 +0100
+++ jruby-1.7.19@iofoo/gems/log4r-1.1.10/lib/log4r/outputter/outputterfactory.rb        2015-05-13 12:59:39.473668715 +0200
@@ -3,6 +3,7 @@
 
 require "log4r/base"
 require "log4r/repository"
+require "log4r/logger"
 
 require 'monitor'
 
diff -Naur jruby-1.7.5@io/gems/log4r-1.1.10/lib/log4r.rb jruby-1.7.19@iofoo/gems/log4r-1.1.10/lib/log4r.rb
--- jruby-1.7.5@io/gems/log4r-1.1.10/lib/log4r.rb       2015-01-08 13:37:11.003755250 +0100
+++ jruby-1.7.19@iofoo/gems/log4r-1.1.10/lib/log4r.rb   2015-05-13 12:59:39.637671121 +0200
@@ -12,7 +12,6 @@
 require "log4r/outputter/rollingfileoutputter"
 require "log4r/formatter/patternformatter"
 require "log4r/loggerfactory"
-require "log4r/logger"
 require "log4r/GDC"
 require "log4r/NDC"
 require "log4r/MDC"
EOF

set +x
