# encoding: utf-8
# license: gpl2p

### BEGIN LICENSE NOTICE
# This file is part of %LONG% (%SHORT%)
# Copyright (C) 2010 - %YEAR%
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
Ghun::Base.relative_require_if_exists(__FILE__,'ifmapj-2.2.2.jar')

module IfMap21
  java_import 'de.hshannover.f4.trust.ifmapj21.ClockSkewDetector'
end

module IfMap
  java_import 'de.hshannover.f4.trust.ifmapj.IfmapJ'
  java_import 'de.hshannover.f4.trust.ifmapj.IfmapJHelper'

  module Binding
    java_import 'de.hshannover.f4.trust.ifmapj.binding.IfmapStrings'
  end

  module Channel
    java_import 'de.hshannover.f4.trust.ifmapj.channel.AbstractChannel'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.AbstractCommunicationHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.ApacheCoreCommunicationHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.ARC'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.ArcImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.CommunicationHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.CommunicationHandlerFactory'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.IfmapChannel'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.JavaCommunicationHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.SSRC'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.SsrcImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.channel.ThreadSafeSsrc'
  end

  module Config
    java_import 'de.hshannover.f4.trust.ifmapj.config.BasicAuthConfig'
    java_import 'de.hshannover.f4.trust.ifmapj.config.CertAuthConfig'
  end

  module Exception
    java_import 'de.hshannover.f4.trust.ifmapj.exception.CommunicationException'
    java_import 'de.hshannover.f4.trust.ifmapj.exception.EndSessionException'
    java_import 'de.hshannover.f4.trust.ifmapj.exception.IfmapErrorCode'
    java_import 'de.hshannover.f4.trust.ifmapj.exception.IfmapErrorResult'
    java_import 'de.hshannover.f4.trust.ifmapj.exception.IfmapException'
    java_import 'de.hshannover.f4.trust.ifmapj.exception.InitializationException'
    java_import 'de.hshannover.f4.trust.ifmapj.exception.MarshalException'
    java_import 'de.hshannover.f4.trust.ifmapj.exception.UnmarshalException'
  end

  module Identifier
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.AccessRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.AccessRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.Device'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.DeviceHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.Identifier'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.IdentifierFactory'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.IdentifierFactoryImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.IdentifierHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.Identifiers'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.IdentifierWithAd'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.Identity'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.IdentityType'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.IpAddress'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.IpAddressHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.IpAddressType'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.MacAddress'
    java_import 'de.hshannover.f4.trust.ifmapj.identifier.MacAddressHandler'
  end

  module Log
    java_import 'de.hshannover.f4.trust.ifmapj.log.IfmapJLog'
    java_import 'de.hshannover.f4.trust.ifmapj.log.IfmapJLogger'
  end

  module Messages
    java_import 'de.hshannover.f4.trust.ifmapj.messages.DumpRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.DumpRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.DumpRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.DumpResult'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.DumpResultImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.EndSessionRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.EndSessionRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.EndSessionRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.GenericObjectHolder'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.IdentifierHolder'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.IdentifierHolderImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.MetadataHolder'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.MetadataHolderImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.MetadataLifetime'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.NamespaceDeclarationHolder'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.NamespaceDeclarationHolderImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.NewSessionRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.NewSessionRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.NewSessionRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.NewSessionResult'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.NewSessionResultImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PollRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PollRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PollRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PollResult'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PollResultImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishDelete'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishDeleteImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishElement'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishNotify'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishNotifyImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishUpdate'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PublishUpdateImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PurgePublisherRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PurgePublisherRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.PurgePublisherRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.RenewSessionRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.RenewSessionRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.RenewSessionRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.Request'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.RequestFactory'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.RequestFactoryImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.RequestFactoryInternal'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.RequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.RequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.Requests'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.Result'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.ResultItem'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.ResultItemImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SearchHolder'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SearchHolderImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SearchRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SearchRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SearchRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SearchResult'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SearchResultImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeDelete'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeDeleteImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeElement'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeElementImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeRequest'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeRequestHandler'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeRequestImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeUpdate'
    java_import 'de.hshannover.f4.trust.ifmapj.messages.SubscribeUpdateImpl'
  end

  module Metadata
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.Cardinality'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.EnforcementAction'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.EventType'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.LocationInformation'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.Metadata'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.MetadataWrapper'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.Significance'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.StandardIfmapMetadataFactory'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.StandardIfmapMetadataFactoryImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.VendorSpecificMetadataFactory'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.VendorSpecificMetadataFactoryImpl'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.WlanSecurityEnum'
    java_import 'de.hshannover.f4.trust.ifmapj.metadata.WlanSecurityType'
  end
end
