# encoding: utf-8
# license: gpl2p 

### BEGIN LICENSE NOTICE
# This file is part of %LONG% (%SHORT%)
# Copyright (C) 2010 - %YEAR%
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
class Switch < ActiveRecord::Base
  belongs_to :location

  has_many :switchmodules, dependent: :destroy
  has_many :switchports, through: :switchmodules

  has_many :neighbour_switchmodules, through: :switchmodules, class_name: Switchmodule, source: :neighbours
  has_many :neighbours, through: :neighbour_switchmodules, class_name: Switch, source: :switch

  has_many :vlans, through: :switchports

  def to_s
    name
  end

end
