#!/bin/bash
# license: gpl2p 

### BEGIN LICENSE NOTICE
# This file is part of %LONG% (%SHORT%)
# Copyright (C) 2010 - %YEAR%
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST

set -eu

APP_PATH="$(dirname $(readlink -f $0))/../"

files="$(find "${APP_PATH}" -type f -name "*.rb")"

for f in ${files}; do
  if ! grep -e "^# *encoding" "${f}" > /dev/null;  then
    t=$(mktemp 2> /dev/null)
    cp "${f}" "${t}"
    declare -i skip=0
    if head -n1 "${f}" | grep -e '^#!' > /dev/null; then
      skip=$((${skip}+1))
    fi
    if [ ${skip} -ne 0 ]; then
      head -n${skip} "${t}" > "${f}"
      echo "# encoding: utf-8" >> "${f}"
      tail -n+$((${skip}+1)) "${t}" >> "${f}"
    else
      echo "# encoding: utf-8" > "${f}"
      cat "${t}" >> "${f}"
    fi
    rm "${t}"
  fi
done

